/*
 * Copyright (c) 2002-2008 LWJGL Project
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 * * Redistributions of source code must retain the above copyright
 *   notice, this list of conditions and the following disclaimer.
 *
 * * Redistributions in binary form must reproduce the above copyright
 *   notice, this list of conditions and the following disclaimer in the
 *   documentation and/or other materials provided with the distribution.
 *
 * * Neither the name of 'LWJGL' nor the names of
 *   its contributors may be used to endorse or promote products derived
 *   from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package org.lwjgl.util.generator;

import java.nio.ByteBuffer;
import javax.lang.model.element.ElementKind;
import javax.lang.model.type.*;
import javax.lang.model.util.SimpleTypeVisitor6;

/**
 * A TypeVisitor that translates (annotated) TypeMirrors to type descriptors.
 */
public final class DescriptorTypeTranslator extends SimpleTypeVisitor6<Void, Void> {

	private String descriptor;

	public void descriptor(String descriptor) {
		this.descriptor = descriptor;
	}

	public String descriptor() {
		return descriptor;
	}

	@Override
	public Void visitArray(ArrayType t, Void o) {
		final DescriptorTypeTranslator translator = new DescriptorTypeTranslator();
		translator.visit(t.getComponentType());
		descriptor(forArray(translator.descriptor()));
		return DEFAULT_VALUE;
	}

	@Override
	public Void visitPrimitive(PrimitiveType t, Void p) {
		descriptor(forPrimitive(t.getKind()));
		return DEFAULT_VALUE;
	}

	@Override
	public Void visitDeclared(DeclaredType t, Void o) {
		ElementKind kind = t.asElement().getKind();
		if (kind.isClass() || kind.isInterface()) {
			descriptor(forClass(t.toString()));
			return DEFAULT_VALUE;
		}

		throw new RuntimeException(t.asElement().getKind() + " is not allowed");
	}

	@Override
	public Void visitNoType(NoType t, Void p) {
		descriptor(forClass(void.class));
		return DEFAULT_VALUE;
	}

	public static String forArray(String componentType) {
		return '[' + componentType;
	}

	public static String forClass(String qualName) {
		return 'L' + qualName.replace('.', '/') + ';';
	}

	public static String forPrimitive(TypeKind kind) {
		switch (kind) {
			case LONG:
				return forClass(long.class);
			case INT:
				return forClass(int.class);
			case DOUBLE:
				return forClass(double.class);
			case FLOAT:
				return forClass(float.class);
			case SHORT:
				return forClass(short.class);
			case BYTE:
				return forClass(byte.class);
			case BOOLEAN:
				return forClass(boolean.class);
			case CHAR:
				return forClass(char.class);
			default:
				throw new RuntimeException(kind + " is not a primitive");
		}
	}

	public static String forClass(Class<?> clazz) {
		if (clazz == long.class) return "J";
		else if (clazz == int.class) return "I";
		else if (clazz == double.class) return "D";
		else if (clazz == float.class) return "F";
		else if (clazz == short.class) return "S";
		else if (clazz == byte.class) return "B";
		else if (clazz == boolean.class) return "Z";
		else if (clazz == char.class) return "C";
		else if (clazz == void.class) return "V";
		else if (clazz.isArray()) return forArray(forClass(clazz.componentType()));
		return forClass(clazz.getName());
	}
}
